<template>
    <div>
        <b-modal ref="putmodal" hide-footer id="modal-1" title="Gruppe editieren">
            <div class="form-group">
                <form method="put" @submit.prevent="putGruppe()">
                    <label for="">Art der Ausbildung wählen</label>
                    <select class="form-control form-select-lg mb-3" name="Art der Ausbildung" id=""
                        v-model="gruppeUpdate.artDerAusbildung">
                        <option value="SW">Softwareentwicklung</option>
                        <option value="NT">Netzwerk</option>
                        <option value="FIA">FIA</option>
                    </select>
                    <input type="text" name="name" id="" placeholder="Gruppennummer"
                        v-model="gruppeUpdate.gruppenNummer" class="form-control"> <br>
                    <label for="">Im Qualifying?</label>
                    <select class="form-control form-select-lg mb-3" name="Gruppe Art" id=""
                        v-model="gruppeUpdate.qualifying">
                        <option value="true">Ja</option>
                        <option value="false">Nein</option>
                    </select>
                    <br>
                    <select class="form-control form-select-lg mb-3" name="TrainerAnstellung" id=""
                        v-model="gruppeUpdate.raumId">
                        <option v-for="(raum, id) in alleRaeume" :key='id' :value="raum.id">
                            {{ raum.raumBezeichnung }}{{ raum.raumNummer }}</option>
                    </select>
                    <button type="submit" class="btn container-fluid btn-info">Speichern</button>
                </form>
            </div>

        </b-modal>

        <table class="table">
            <th>ID</th>
            <th>Gruppen-Nr</th>
            <th>Name</th>
            <th>Art der Ausbildung</th>
            <th>Qualifying</th>
            <th>Teilnehmer der Gruppe</th>
            <th>Raum der Gruppe</th>
            <th></th>
            <tr v-for="(gruppe, id) in alleGruppen" :key='id'>
                <td>{{ gruppe.id }}</td>
                <td>{{ gruppe.gruppenNummer }}</td>
                <td>{{ gruppe.artDerAusbildung }}{{ gruppe.gruppenNummer }}</td>
                <td>{{ gruppe.artDerAusbildung }}</td>
                <td>{{ gruppe.qualifying }}</td>
                <td>
                    <table class="table thead-light">
                        <th>Name</th>
                        <th>ID</th>
                        <tr v-for="(teilnehmer, id) in gruppe.TeilnehmerInSet" :key='id'>
                            <td>{{ teilnehmer.name }}</td>
                            <td>{{ teilnehmer.id }}</td>
                        </tr>
                    </table>
                </td>
                <td>{{ gruppe.raum.raumNummer }} {{ gruppe.raum.raumBezeichnung }}</td>
                <td>
                    <button type="button" class="btn btn-danger m-1" @click="deleteGruppe(gruppe.id)">X</button>
                    <button type="button" class="btn btn-primary m-1" v-b-modal.modal-1
                        @click="editGruppe(gruppe)">O</button>
                </td>
            </tr>
        </table>
    </div>
</template>

<script>


export default {
    name: 'GruppenSeite',
    data() {
        return {
            gruppeUpdate: {
                gruppenNummer: '',
                artDerAusbildung: '',
                qualifying: '',
                raumId: '',
                id: '',
            }
        };
    },

    computed: {
        alleGruppen() {
            return this.$store.state.alleGruppen
        },

        alleTeilnehmer() {
            return this.$store.state.alleTeilnehmer
        },

        alleRaeume() {
            return this.$store.state.alleRaeume;
        },
    },

    mounted() {
        this.$store.dispatch('getAlleGruppen');
        this.$store.dispatch("getAlleRaeume");
        this.$store.dispatch("getAlleTeilmehmer");
    },

    components: {
    },

    methods: {

        async deleteGruppe(id) {
            const deleteGruppe = this.$store.dispatch('deleteGruppe', id)
            console.log(deleteGruppe)
        },

        async editGruppe(gruppe) {
            this.gruppeUpdate = gruppe;
        },

        async putGruppe() {
            this.$store.dispatch("putGruppe", this.gruppeUpdate)
            this.hideModal();
        },

        hideModal() {
            this.$refs['putmodal'].hide();
        }
    }




}
</script>